
# Reapplication des modifs locales suite à upgrade serveur

Voila les opérations que j ai faite en direct pour mettre a jour notre scodoc local apres un upgrade de scodoc

l'exemple ici fait suite à l upgrade 9.1.55 -> 9.1.56
le no de version (9.1.56) devrait être un parametre d'un éventuel script

Note preliminaire:
- j ai installé git sur iut-scodoc
- on travaille avec les réperoires:
    - /opt/scodoc   répértoire de production
    - /opt/scodoc-local  les fichiers différentes entre la version lillooise et la version officielle
    - /opt/ScoDoc-git  le working-dir de git

Tous ces répertoires doivent être la propriété de l'user `scodoc
   
Je pars d'un situation où le working dir est sur la branche `local`, que le depot distant git contient la dernière version et que /opt/scodoc a déjà été mis à jour

Mise en place
```bash
cd /opt/ScoDoc-git/
su scodoc
```

première vérification que l on est bien sur la branche `local` et à jour (sinon faire `git checkout local`)
```bash
git status
Sur la branche local
rien à valider, la copie de travail est propre

git log -1
commit 322090276326c36e8d5525372e3e0804569b70ac (HEAD -> local)
Merge: 574fede 514a09e
Author: jean-marie Place (as scodoc) <jean-marie.place@univ-lille.fr>
Date:   Mon Feb 14 16:49:36 2022 +0100

    Merge tag '9.1.55' into local

    9.1 220213
```

Recpie en local de l'historique officiel (contient la nouvelle version (ici 9.1.56) en tant que tag)
```bash
git fetch
remote: Enumerating objects: 32, done.
remote: Counting objects: 100% (32/32), done.
remote: Compressing objects: 100% (17/17), done.
remote: Total 17 (delta 15), reused 0 (delta 0), pack-reused 0
Dépaquetage des objets: 100% (17/17), 2.64 Kio | 246.00 Kio/s, fait.
Depuis https://scodoc.org/git/ScoDoc/ScoDoc
   0196d41..60a77b8  dev92      -> origin/dev92
 * [nouvelle étiquette] 9.1.56     -> 9.1.56
```

Intégration des dernières midif officielles dans la branche locale
Il est possible que la fusion déclenche une erreur à ce niveai si la mise à jour officielle concerne un des fichiers modifiés localalement
Dans ce cas, pas d'autre solution que de verifier la fusion à la main

si procedure automatisée, prévoir un arrêt éventuel à ce niveau (basé sur la valeur de retour gu git merge ?)

```bash
git merge origin 9.1.56
Fusion automatique de app/views/notes.py
Fusion automatique de app/scodoc/sco_formsemestre_status.py
Merge made by the 'recursive' strategy.
 app/but/bulletin_but.py                     |  2 +-
 app/but/bulletin_but_xml_compat.py          | 26 ++++++++++++++++----------
 app/comp/res_common.py                      | 11 +++++++++++
 app/models/moduleimpls.py                   |  2 +-
 ......
 ......
 app/templates/pn/form_ues.html              |  5 +++++
 app/templates/pn/ue_infos.html              |  2 +-
 app/views/absences.py                       |  4 +++-
 app/views/notes.py                          |  2 +-
 sco_version.py                              |  2 +-
 35 files changed, 149 insertions(+), 90 deletions(-)
```

Si tout s est bien passé, vérification

```bash
git status
Sur la branche local
rien à valider, la copie de travail est propre
```

Enumération des fichiers modifiés localement
```bash
git diff --name-only 9.1.56
app/scodoc/sco_excel.py
app/scodoc/sco_excel_add.py
app/scodoc/sco_formsemestre_status.py
app/scodoc/sco_prepajury_formats.py
app/scodoc/sco_prepajury_iuta.py
app/views/notes.py
app/views/scolar.py
```

et recopie des diffs dans `/opt/scodoc-local/`
(pour l instant 2 sous répertoires /app/scodoc et /app/views) 
TODO adapter la commande pour créer d'autres sous-répertoires si besoin (actuellement -> erreur bash)

```bash
for f in $(git diff --name-only 9.1.56); do cp -p $f /opt/scodoc-local/$f ; done
```

Si tout s'est bien passé jusque là recopie des fichiers diffs en production
```bash
for f in $(git diff --name-only 9.1.56); do cp -p $f /opt/scodoc/$f ; done
```

Effacement du cache REDIS (préservé même en cas de redémarrage serveur) 
Et relance du serveur

```bash
cd /opt/scodoc
source venv/bin/activate
flask clear-cache

exit
systemctl restart scodoc9
```

# Ajout d'autres adaptations locales

Ajouter les nouvelles modifs à la branche `local`du git

Et compléter ci-dessous.

## Adaptations actuelles
- Ajout mention adaptation local à l'écran principal
- api: formsemestre_partition_list
- Ajout dans le menu de `Générer feuille préparation Jury (DUT)`
- TODO: poursuite d'études
- TODO: Affichage des étiquettes étudiant


